"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/divider.tsx
var divider_exports = {};
__export(divider_exports, {
  CDivider: () => CDivider
});
module.exports = __toCommonJS(divider_exports);
var import_vue = require("vue");
var import_vue2 = require("vue");
var import_vue_system = require("@chakra-ui/vue-system");
var import_utils = require("@chakra-ui/utils");
var import_vue_utils = require("@chakra-ui/vue-utils");
var CDivider = (0, import_vue2.defineComponent)({
  name: "CDivider",
  props: {
    orientation: {
      type: [String],
      default: "horizontal"
    },
    ...import_vue_utils.vueThemingProps
  },
  setup(props, {
    slots,
    attrs
  }) {
    const themingProps = (0, import_vue2.computed)(() => (0, import_utils.filterUndefined)({
      colorScheme: props.colorScheme,
      variant: props.variant,
      size: props.size,
      styleConfig: props.styleConfig,
      orientation: props.orientation
    }));
    const styles = (0, import_vue_system.useStyleConfig)("Divider", themingProps);
    const {
      borderLeftWidth,
      borderBottomWidth,
      borderTopWidth,
      borderRightWidth,
      borderWidth,
      borderStyle,
      borderColor,
      ...stylesRest
    } = styles.value;
    const dividerStyle = (0, import_vue2.computed)(() => {
      const dividerStyles = {
        vertical: {
          borderLeftWidth: borderLeftWidth || borderRightWidth || borderWidth || "1px",
          height: "100%"
        },
        horizontal: {
          borderBottomWidth: borderBottomWidth || borderTopWidth || borderWidth || "1px",
          width: "100%"
        }
      };
      return dividerStyles[props.orientation];
    });
    return () => (0, import_vue.createVNode)(import_vue_system.chakra.hr, {
      "aria-orientation": props.orientation,
      "__css": {
        ...stylesRest,
        border: 0,
        borderColor,
        borderStyle,
        ...dividerStyle.value
      },
      "__label": "divider"
    }, {
      default: () => {
        var _a;
        return [(_a = slots.default) == null ? void 0 : _a.call(slots)];
      }
    });
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CDivider
});
