import * as vue from 'vue';
import { PropType } from 'vue';
import * as _chakra_ui_styled_system from '@chakra-ui/styled-system';
import { SystemProps } from '@chakra-ui/styled-system';
import { HTMLChakraProps } from '@chakra-ui/vue-system';
import * as CSS from 'csstype';

interface FlexProps extends HTMLChakraProps<"div"> {
    /**
     * Shorthand for `alignItems` style prop
     * @type SystemProps["alignItems"]
     * SystemProps because prop can be String, Array or Object
     */
    align?: SystemProps["alignItems"];
    /**
     * Shorthand for `justifyContent` style prop
     * @type SystemProps["justifyContent"]
     */
    justify?: SystemProps["justifyContent"];
    /**
     * Shorthand for `flexWrap` style prop
     * @type SystemProps["flexWrap"]
     */
    wrap?: SystemProps["flexWrap"];
    /**
     * Shorthand for `flexDirection` style prop
     * @type SystemProps["flexDirection"]
     */
    direction?: SystemProps["flexDirection"];
    /**
     * Shorthand for `flexBasis` style prop
     * @type SystemProps["flexBasis"]
     */
    basis?: SystemProps["flexBasis"];
    /**
     * Shorthand for `flexGrow` style prop
     * @type SystemProps["flexGrow"]
     */
    grow?: SystemProps["flexGrow"];
    /**
     * Shorthand for `flexShrink` style prop
     * @type SystemProps["flexShrink"]
     */
    shrink?: SystemProps["flexShrink"];
}
declare const CFlex: vue.DefineComponent<{
    as: {
        type: PropType<"a" | "article" | "aside" | "b" | "blockquote" | "button" | "caption" | "cite" | "code" | "dd" | "div" | "dl" | "dt" | "fieldset" | "figcaption" | "figure" | "footer" | "form" | "h1" | "h2" | "h3" | "h4" | "h5" | "h6" | "header" | "hr" | "iframe" | "img" | "input" | "kbd" | "label" | "li" | "main" | "mark" | "nav" | "ol" | "p" | "pre" | "q" | "s" | "section" | "select" | "small" | "span" | "strong" | "sub" | "sup" | "table" | "tbody" | "td" | "textarea" | "tfoot" | "th" | "thead" | "tr" | "ul" | "svg" | "circle" | "path" | "rect">;
        default: string;
    };
    align: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.AlignItems> | undefined>;
    justify: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.JustifyContent> | undefined>;
    wrap: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.FlexWrap> | undefined>;
    direction: {
        type: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.FlexDirection> | undefined>;
        default: string;
    };
    basis: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.FlexBasis<string | number>> | undefined>;
    grow: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.FlexGrow> | undefined>;
    shrink: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.FlexShrink> | undefined>;
    size: PropType<any>;
}, () => JSX.Element, unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {}, string, vue.VNodeProps & vue.AllowedComponentProps & vue.ComponentCustomProps, Readonly<vue.ExtractPropTypes<{
    as: {
        type: PropType<"a" | "article" | "aside" | "b" | "blockquote" | "button" | "caption" | "cite" | "code" | "dd" | "div" | "dl" | "dt" | "fieldset" | "figcaption" | "figure" | "footer" | "form" | "h1" | "h2" | "h3" | "h4" | "h5" | "h6" | "header" | "hr" | "iframe" | "img" | "input" | "kbd" | "label" | "li" | "main" | "mark" | "nav" | "ol" | "p" | "pre" | "q" | "s" | "section" | "select" | "small" | "span" | "strong" | "sub" | "sup" | "table" | "tbody" | "td" | "textarea" | "tfoot" | "th" | "thead" | "tr" | "ul" | "svg" | "circle" | "path" | "rect">;
        default: string;
    };
    align: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.AlignItems> | undefined>;
    justify: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.JustifyContent> | undefined>;
    wrap: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.FlexWrap> | undefined>;
    direction: {
        type: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.FlexDirection> | undefined>;
        default: string;
    };
    basis: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.FlexBasis<string | number>> | undefined>;
    grow: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.FlexGrow> | undefined>;
    shrink: PropType<_chakra_ui_styled_system.ResponsiveValue<CSS.Property.FlexShrink> | undefined>;
    size: PropType<any>;
}>>, {
    as: "a" | "article" | "aside" | "b" | "blockquote" | "button" | "caption" | "cite" | "code" | "dd" | "div" | "dl" | "dt" | "fieldset" | "figcaption" | "figure" | "footer" | "form" | "h1" | "h2" | "h3" | "h4" | "h5" | "h6" | "header" | "hr" | "iframe" | "img" | "input" | "kbd" | "label" | "li" | "main" | "mark" | "nav" | "ol" | "p" | "pre" | "q" | "s" | "section" | "select" | "small" | "span" | "strong" | "sub" | "sup" | "table" | "tbody" | "td" | "textarea" | "tfoot" | "th" | "thead" | "tr" | "ul" | "svg" | "circle" | "path" | "rect";
    direction: _chakra_ui_styled_system.ResponsiveValue<CSS.Property.FlexDirection> | undefined;
}>;

export { CFlex, FlexProps };
