"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/list.tsx
var list_exports = {};
__export(list_exports, {
  CList: () => CList,
  CListIcon: () => CListIcon,
  CListItem: () => CListItem,
  COrderedList: () => COrderedList,
  CUnorderedList: () => CUnorderedList
});
module.exports = __toCommonJS(list_exports);
var import_vue = require("vue");
var import_c_icon = require("@chakra-ui/c-icon");
var import_vue_system = require("@chakra-ui/vue-system");
var import_vue2 = require("vue");
var import_vue_system2 = require("@chakra-ui/vue-system");
var import_vue_utils = require("@chakra-ui/vue-utils");
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !(0, import_vue.isVNode)(s);
}
__name(_isSlot, "_isSlot");
var CList = (0, import_vue2.defineComponent)({
  name: "CList",
  props: {
    as: {
      type: [Object, String],
      default: "ul"
    },
    styleType: {
      type: import_vue_utils.SAO,
      default: "none"
    },
    stylePosition: import_vue_utils.SAO,
    spacing: import_vue_utils.SNAO
  },
  setup(props, {
    slots,
    attrs
  }) {
    const styles = (0, import_vue_system.useMultiStyleConfig)("List", props);
    (0, import_vue_system.StylesProvider)(styles);
    const selector = "& > *:not(style) ~ *:not(style)";
    const spacingStyle = (0, import_vue2.computed)(() => props.spacing ? {
      [selector]: {
        mt: props.spacing
      }
    } : {});
    return () => {
      const validChildren = /* @__PURE__ */ __name(() => (0, import_vue_utils.getValidChildren)(slots), "validChildren");
      return (0, import_vue.createVNode)(import_vue_system2.chakra.ul, (0, import_vue.mergeProps)({
        "__label": "list",
        "as": props.as,
        "listStyleType": props.styleType,
        "listStylePosition": props.stylePosition,
        "role": "list",
        "__css": {
          ...styles.value.container,
          ...spacingStyle.value
        }
      }, attrs), _isSlot(validChildren) ? validChildren : {
        default: () => [validChildren]
      });
    };
  }
});
var COrderedList = (0, import_vue2.defineComponent)({
  name: "COrderedList",
  setup(props, {
    slots,
    attrs
  }) {
    return () => (0, import_vue.createVNode)(CList, (0, import_vue.mergeProps)({
      "styleType": "decimal",
      "marginStart": "1em"
    }, attrs), _isSlot(slots) ? slots : {
      default: () => [slots]
    });
  }
});
var CUnorderedList = (0, import_vue2.defineComponent)({
  name: "CUnorderedList",
  setup(props, {
    slots,
    attrs
  }) {
    return () => (
      // @ts-ignore
      (0, import_vue.createVNode)(CList, (0, import_vue.mergeProps)({
        "styleType": "initial",
        "marginStart": "1em"
      }, attrs), _isSlot(slots) ? slots : {
        default: () => [slots]
      })
    );
  }
});
var CListItem = (0, import_vue2.defineComponent)({
  name: "CListItem",
  setup(_, {
    slots,
    attrs
  }) {
    const styles = (0, import_vue_system.useStyles)();
    return () => {
      return (0, import_vue.createVNode)(import_vue_system2.chakra.li, (0, import_vue.mergeProps)({
        "__label": "list__item",
        "__css": styles.value.item
      }, attrs), _isSlot(slots) ? slots : {
        default: () => [slots]
      });
    };
  }
});
var CListIcon = (0, import_vue2.defineComponent)({
  name: "CListIcon",
  setup(_, {
    slots,
    attrs
  }) {
    const styles = (0, import_vue_system.useStyles)();
    return () => {
      return (0, import_vue.createVNode)(import_c_icon.CIcon, (0, import_vue.mergeProps)({
        "role": "presentation"
      }, attrs, {
        "__css": styles.value.icon
      }), _isSlot(slots) ? slots : {
        default: () => [slots]
      });
    };
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CList,
  CListIcon,
  CListItem,
  COrderedList,
  CUnorderedList
});
